﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using UnityEngine.EventSystems;

public class CanvasIntro : MonoBehaviour 
{
	[SerializeField] private Transform _splash;
	[SerializeField] private EventSystem _eSystem;
	[SerializeField] private GameObject _startButton, _resumeButton;

	private Color _offColor, _onColor;

	void Start () 
	{
		_onColor = new Color (0, 0, 0, 1);
		_offColor = new Color (0, 0, 0, 0);
		_splash.GetChild (0).gameObject.SetActive (false);
		_splash.GetChild (1).gameObject.SetActive (false);
		_eSystem.enabled = false;

		StartCoroutine (Splash ());
	}

	IEnumerator Splash()
	{
		Image black = _splash.GetChild (_splash.childCount-1).GetComponent<Image> ();
		for (int i = 0; i < _splash.childCount; i++) 
		{
			
			
			float alfa = 1;
			_splash.GetChild (i).gameObject.SetActive (true);

			yield return new WaitForSeconds (1f);

			while(black.color.a > _offColor.a)
			{
				alfa -= Time.deltaTime;
				black.color = new Color (0, 0, 0, alfa);
				yield return null;
			}

			if (i == 2) 
			{
				_eSystem.enabled = true;

				if (_resumeButton.activeSelf == true)
					_eSystem.SetSelectedGameObject (_resumeButton);
				else
					_eSystem.SetSelectedGameObject (_startButton);

				break;
			}
				

			yield return new WaitForSeconds (3f);

			while(black.color.a < _onColor.a)
			{
				alfa += Time.deltaTime * 2f;
				black.color = new Color (0, 0, 0, alfa);
				yield return null;
			}

			_splash.GetChild (i).gameObject.SetActive (false);
		}
	}
}
