﻿using UnityEngine;
using System.Collections;

public class EinbaumMover : MonoBehaviour 
{
	// ----------------------------------------------------------------------------------------

	private Transform _caveman;
	private Vector3 _lastPos;
	private BoxCollider2D _boxCollider;
	[SerializeField] private LayerMask carrier;

	void Start () 
	{
		_caveman = GameObject.FindObjectOfType<CaveManActor>().transform;
		_boxCollider = transform.GetComponent<BoxCollider2D>();
		_lastPos = transform.position;
	}

	// ----------------------------------------------------------------------------------------

	void Update () 
	{
		RaycastHit2D hit = Physics2D.BoxCast(transform.position, transform.GetComponent<BoxCollider2D>().size, 0, Vector2.up, 3f, carrier);
		//Collider2D hit = Physics2D.OverlapArea((Vector2)transform.position + Vector2.up * _boxCollider.size.y,
		//	(Vector2)transform.position + Vector2.right * _boxCollider.size.x + Vector2.up);


		if (transform.position.x > 26.8f) 
		{
			transform.position = Vector3.MoveTowards (transform.position, GameObject.Find ("SpawnPoints").transform.GetChild (2).position, Time.deltaTime * 3f);
			Camera.main.GetComponent<CameraController> ().target = _caveman;
		}

		if (transform.position.x > 137f) 
		{
			GameManager.instance.LoadScene (0);
		}
			
		Vector3 posDiff = transform.position - _lastPos;

		if (hit)
		{
			hit.transform.position += posDiff;
		}


		_lastPos = transform.position;
	}
}
