﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;
using System.Collections;

[RequireComponent(typeof(Animator))]
public class Flammable : MonoBehaviour
{
	[SerializeField] private Wind _linkedWind;
    private Animator _animator;

    //----------------------------------------------------------------------------------------------------

    private void Awake()
    {
        _animator = GetComponent<Animator>();
    }

    //----------------------------------------------------------------------------------------------------

    private void OnTriggerEnter2D(Collider2D other)
    {
        if (other.CompareTag("Caveman"))
        {
           if(other.GetComponent<CaveManActor>().IsTorchEquipped)
			{
				_animator.SetTrigger("Burn");
				StartCoroutine(Burn());
			}              
        }
    }

    //----------------------------------------------------------------------------------------------------

	private IEnumerator Burn()
	{
		yield return null;

		while(_animator.IsInTransition(0) || _animator.GetCurrentAnimatorStateInfo(0).normalizedTime < 1f)
			yield return null;

		if(_linkedWind != null)
			_linkedWind.enabled = true;

		Destroy(gameObject);
	}

	//----------------------------------------------------------------------------------------------------
}