﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

[RequireComponent(typeof(CharacterController2D))]
public class Interactable : MonoBehaviour
{
    public float gravity = -5f;
    [Range(1,3)]
    public int weight = 1;
    public CharacterController2D.CollisionData CollisionData { get { return _controller.collisionData; } }

    private Vector2 _velocity;
    private CharacterController2D _controller;

    // ----------------------------------------------------------------------------------------

    protected virtual void Awake()
    {
        _controller = GetComponent<CharacterController2D>();
    }

    // ----------------------------------------------------------------------------------------

    protected virtual void Update()
    {
        _velocity.y += gravity * Time.deltaTime;
        _controller.Move(_velocity * Time.deltaTime);

        if (CollisionData.top || CollisionData.bottom)
        {
            _velocity.y = 0;
        }
    }

    // ----------------------------------------------------------------------------------------

    public void Move(Vector2 velocity)
    {
        _controller.Move(velocity);
    }

    // ----------------------------------------------------------------------------------------

}