﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(Animator))]
public class PlayIntroAnimation : MonoBehaviour 
{
	//--- MEMBERS -----------------------------------------------------------------------------------------

	[SerializeField] private Animator _playerAnimator;
	[SerializeField] private Animator _bubbleAnimator;
	private Animator _treeAnimator;
	private GameObject _torch;
	

	//---- METHODS ----------------------------------------------------------------------------------------

	private void Awake()
	{
		_treeAnimator = GetComponent<Animator>();
		_torch = _playerAnimator.transform.FindChild("Torch").gameObject;
		_torch.SetActive(false);
	}

	//-----------------------------------------------------------------------------------------------------

	private void Start() 
	{
		_playerAnimator.GetComponent<Actor>().enabled = false;
		_treeAnimator.SetTrigger("Intro");
		_playerAnimator.SetTrigger("Intro");
		StartCoroutine(MovePlayer());
	}

	//-----------------------------------------------------------------------------------------------------

	private IEnumerator MovePlayer()
	{
		yield return new WaitForSeconds(0.5f);
		float time = 0f;
		while(time < 2f)
		{
			_playerAnimator.transform.position += Vector3.right * Time.deltaTime * 2f;
			time += Time.deltaTime;
			yield return null;
		}

		yield return new WaitForSeconds(1.5f);
		time = 0f;
		while(time < 1.9f)
		{
			_playerAnimator.transform.position += Vector3.right * Time.deltaTime * 1.7f;
			time += Time.deltaTime;
			yield return null;
		}

		_playerAnimator.SetBool("HasTorch", true);
		while(_playerAnimator.GetCurrentAnimatorStateInfo(0).normalizedTime < 1f)
			yield return null;

		_torch.SetActive(true);
		_playerAnimator.SetBool ("Walking", true);

		time = 0f;
		while(time < 10f)
		{
			_playerAnimator.transform.position += Vector3.right * Time.deltaTime * 2.2f;

			if (time > 5) 
			{
				if(_bubbleAnimator.GetBool ("isOn") == false)
					_bubbleAnimator.SetBool ("isOn", true);
				
				_bubbleAnimator.transform.position += Vector3.right * Time.deltaTime * 2.2f;
			}

			time += Time.deltaTime;

			yield return null;
		}

		Destroy(this);
	}

	//-----------------------------------------------------------------------------------------------------
}