﻿using System.Collections.Generic;
using System.Xml;
using System.Xml.Serialization;
using System.IO;
using UnityEngine;

[XmlRoot("SaveInformation")]
public class XmlManager 
{

	//--- MEMBERS -----------------------------------------------------------------------------------------

	[XmlElement("Scene")]
	public int scene = 0;
	[XmlElement("Checkpoint")]
	public int checkPoint = 0;

	private static string _path = Path.Combine(Application.dataPath, "data.cp");

	//---- METHODS ----------------------------------------------------------------------------------------

	public void Save()
	{	
		var serializer = new XmlSerializer(typeof(XmlManager));
		using(var stream = new FileStream(_path, FileMode.Create))
		{
			serializer.Serialize(stream, this);
		}
	}

	//-----------------------------------------------------------------------------------------------------

	public static XmlManager Load()
	{
		var serializer = new XmlSerializer(typeof(XmlManager));
		using(var stream = new FileStream(_path, FileMode.Open))
		{
			return serializer.Deserialize(stream) as XmlManager;
		}
	}

}
